Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -2041,7 +7645,8 @@
             public double epsx;
             public int maxits;
-            public int flags;
             public bool xrep;
             public double stpmax;
+            public double[] s;
+            public double diffstep;
             public int nfev;
             public int mcstage;
@@ -2050,6 +7655,6 @@
             public int p;
             public double[] rho;
-            public double[,] y;
-            public double[,] s;
+            public double[,] yk;
+            public double[,] sk;
             public double[] theta;
             public double[] d;
@@ -2057,11 +7662,19 @@
             public double[] work;
             public double fold;
+            public double trimthreshold;
             public int prectype;
             public double gammak;
             public double[,] denseh;
+            public double[] diagh;
+            public double fbase;
+            public double fm2;
+            public double fm1;
+            public double fp1;
+            public double fp2;
             public double[] autobuf;
             public double[] x;
             public double f;
             public double[] g;
+            public bool needf;
             public bool needfg;
             public bool xupdated;
@@ -2073,11 +7686,13 @@
             public minlbfgsstate()
             {
+                s = new double[0];
                 rho = new double[0];
-                y = new double[0,0];
-                s = new double[0,0];
+                yk = new double[0,0];
+                sk = new double[0,0];
                 theta = new double[0];
                 d = new double[0];
                 work = new double[0];
                 denseh = new double[0,0];
+                diagh = new double[0];
                 autobuf = new double[0];
                 x = new double[0];
@@ -2097,4 +7712,7 @@
 
 
+
+
+        public const double gtol = 0.4;
 
 
@@ -2164,5 +7782,69 @@
             ap.assert(ap.len(x)>=n, "MinLBFGSCreate: Length(X)<N!");
             ap.assert(apserv.isfinitevector(x, n), "MinLBFGSCreate: X contains infinite or NaN values!");
-            minlbfgscreatex(n, m, x, 0, state);
+            minlbfgscreatex(n, m, x, 0, 0.0, state);
+        }
+
+
+        /*************************************************************************
+        The subroutine is finite difference variant of MinLBFGSCreate().  It  uses
+        finite differences in order to differentiate target function.
+
+        Description below contains information which is specific to  this function
+        only. We recommend to read comments on MinLBFGSCreate() in  order  to  get
+        more information about creation of LBFGS optimizer.
+
+        INPUT PARAMETERS:
+            N       -   problem dimension, N>0:
+                        * if given, only leading N elements of X are used
+                        * if not given, automatically determined from size of X
+            M       -   number of corrections in the BFGS scheme of Hessian
+                        approximation update. Recommended value:  3<=M<=7. The smaller
+                        value causes worse convergence, the bigger will  not  cause  a
+                        considerably better convergence, but will cause a fall in  the
+                        performance. M<=N.
+            X       -   starting point, array[0..N-1].
+            DiffStep-   differentiation step, >0
+
+        OUTPUT PARAMETERS:
+            State   -   structure which stores algorithm state
+
+        NOTES:
+        1. algorithm uses 4-point central formula for differentiation.
+        2. differentiation step along I-th axis is equal to DiffStep*S[I] where
+           S[] is scaling vector which can be set by MinLBFGSSetScale() call.
+        3. we recommend you to use moderate values of  differentiation  step.  Too
+           large step will result in too large truncation  errors, while too small
+           step will result in too large numerical  errors.  1.0E-6  can  be  good
+           value to start with.
+        4. Numerical  differentiation  is   very   inefficient  -   one   gradient
+           calculation needs 4*N function evaluations. This function will work for
+           any N - either small (1...10), moderate (10...100) or  large  (100...).
+           However, performance penalty will be too severe for any N's except  for
+           small ones.
+           We should also say that code which relies on numerical  differentiation
+           is   less  robust  and  precise.  LBFGS  needs  exact  gradient values.
+           Imprecise gradient may slow  down  convergence,  especially  on  highly
+           nonlinear problems.
+           Thus  we  recommend to use this function for fast prototyping on small-
+           dimensional problems only, and to implement analytical gradient as soon
+           as possible.
+
+          -- ALGLIB --
+             Copyright 16.05.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlbfgscreatef(int n,
+            int m,
+            double[] x,
+            double diffstep,
+            minlbfgsstate state)
+        {
+            ap.assert(n>=1, "MinLBFGSCreateF: N too small!");
+            ap.assert(m>=1, "MinLBFGSCreateF: M<1");
+            ap.assert(m<=n, "MinLBFGSCreateF: M>N");
+            ap.assert(ap.len(x)>=n, "MinLBFGSCreateF: Length(X)<N!");
+            ap.assert(apserv.isfinitevector(x, n), "MinLBFGSCreateF: X contains infinite or NaN values!");
+            ap.assert(math.isfinite(diffstep), "MinLBFGSCreateF: DiffStep is infinite or NaN!");
+            ap.assert((double)(diffstep)>(double)(0), "MinLBFGSCreateF: DiffStep is non-positive!");
+            minlbfgscreatex(n, m, x, 0, diffstep, state);
         }
 
@@ -2175,6 +7857,9 @@
             EpsG    -   >=0
                         The  subroutine  finishes  its  work   if   the  condition
-                        ||G||<EpsG is satisfied, where ||.|| means Euclidian norm,
-                        G - gradient.
+                        |v|<EpsG is satisfied, where:
+                        * |.| means Euclidian norm
+                        * v - scaled gradient vector, v[i]=g[i]*s[i]
+                        * g - gradient
+                        * s - scaling coefficients set by MinLBFGSSetScale()
             EpsF    -   >=0
                         The  subroutine  finishes  its work if on k+1-th iteration
@@ -2183,5 +7868,9 @@
             EpsX    -   >=0
                         The subroutine finishes its work if  on  k+1-th  iteration
-                        the condition |X(k+1)-X(k)| <= EpsX is fulfilled.
+                        the condition |v|<=EpsX is fulfilled, where:
+                        * |.| means Euclidian norm
+                        * v - scaled step vector, v[i]=dx[i]/s[i]
+                        * dx - ste pvector, dx=X(k+1)-X(k)
+                        * s - scaling coefficients set by MinLBFGSSetScale()
             MaxIts  -   maximum number of iterations. If MaxIts=0, the  number  of
                         iterations is unlimited.
@@ -2265,4 +7954,50 @@
 
         /*************************************************************************
+        This function sets scaling coefficients for LBFGS optimizer.
+
+        ALGLIB optimizers use scaling matrices to test stopping  conditions  (step
+        size and gradient are scaled before comparison with tolerances).  Scale of
+        the I-th variable is a translation invariant measure of:
+        a) "how large" the variable is
+        b) how large the step should be to make significant changes in the function
+
+        Scaling is also used by finite difference variant of the optimizer  - step
+        along I-th axis is equal to DiffStep*S[I].
+
+        In  most  optimizers  (and  in  the  LBFGS  too)  scaling is NOT a form of
+        preconditioning. It just  affects  stopping  conditions.  You  should  set
+        preconditioner  by  separate  call  to  one  of  the  MinLBFGSSetPrec...()
+        functions.
+
+        There  is  special  preconditioning  mode, however,  which  uses   scaling
+        coefficients to form diagonal preconditioning matrix. You  can  turn  this
+        mode on, if you want.   But  you should understand that scaling is not the
+        same thing as preconditioning - these are two different, although  related
+        forms of tuning solver.
+
+        INPUT PARAMETERS:
+            State   -   structure stores algorithm state
+            S       -   array[N], non-zero scaling coefficients
+                        S[i] may be negative, sign doesn't matter.
+
+          -- ALGLIB --
+             Copyright 14.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlbfgssetscale(minlbfgsstate state,
+            double[] s)
+        {
+            int i = 0;
+
+            ap.assert(ap.len(s)>=state.n, "MinLBFGSSetScale: Length(S)<N");
+            for(i=0; i<=state.n-1; i++)
+            {
+                ap.assert(math.isfinite(s[i]), "MinLBFGSSetScale: S contains infinite or NAN elements");
+                ap.assert((double)(s[i])!=(double)(0), "MinLBFGSSetScale: S contains zero elements");
+                state.s[i] = Math.Abs(s[i]);
+            }
+        }
+
+
+        /*************************************************************************
         Extended subroutine for internal use only.
 
@@ -2276,4 +8011,5 @@
                                     subsequent  calls   of   MinLBFGS   with   same
                                     MinLBFGSState structure can set Flags to 1.
+            DiffStep - numerical differentiation step
 
           -- ALGLIB --
@@ -2284,7 +8020,9 @@
             double[] x,
             int flags,
+            double diffstep,
             minlbfgsstate state)
         {
             bool allocatemem = new bool();
+            int i = 0;
 
             ap.assert(n>=1, "MinLBFGS: N too small!");
@@ -2295,19 +8033,20 @@
             // Initialize
             //
+            state.diffstep = diffstep;
             state.n = n;
             state.m = m;
-            state.flags = flags;
             allocatemem = flags%2==0;
             flags = flags/2;
             if( allocatemem )
             {
-                state.rho = new double[m-1+1];
-                state.theta = new double[m-1+1];
-                state.y = new double[m-1+1, n-1+1];
-                state.s = new double[m-1+1, n-1+1];
-                state.d = new double[n-1+1];
-                state.x = new double[n-1+1];
-                state.g = new double[n-1+1];
-                state.work = new double[n-1+1];
+                state.rho = new double[m];
+                state.theta = new double[m];
+                state.yk = new double[m, n];
+                state.sk = new double[m, n];
+                state.d = new double[n];
+                state.x = new double[n];
+                state.s = new double[n];
+                state.g = new double[n];
+                state.work = new double[n];
             }
             minlbfgssetcond(state, 0, 0, 0, 0);
@@ -2315,4 +8054,8 @@
             minlbfgssetstpmax(state, 0);
             minlbfgsrestartfrom(state, x);
+            for(i=0; i<=n-1; i++)
+            {
+                state.s[i] = 1.0;
+            }
             state.prectype = 0;
         }
@@ -2320,11 +8063,9 @@
 
         /*************************************************************************
-        Modification of the preconditioner:
-        default preconditioner (simple scaling) is used.
+        Modification  of  the  preconditioner:  default  preconditioner    (simple
+        scaling, same for all elements of X) is used.
 
         INPUT PARAMETERS:
             State   -   structure which stores algorithm state
-
-        After call to this function preconditioner is changed to the default one.
 
         NOTE:  you  can  change  preconditioner  "on  the  fly",  during algorithm
@@ -2334,5 +8075,5 @@
              Copyright 13.10.2010 by Bochkanov Sergey
         *************************************************************************/
-        public static void minlbfgssetdefaultpreconditioner(minlbfgsstate state)
+        public static void minlbfgssetprecdefault(minlbfgsstate state)
         {
             state.prectype = 0;
@@ -2341,6 +8082,6 @@
 
         /*************************************************************************
-        Modification of the preconditioner:
-        Cholesky factorization of approximate Hessian is used.
+        Modification of the preconditioner: Cholesky factorization of  approximate
+        Hessian is used.
 
         INPUT PARAMETERS:
@@ -2358,12 +8099,10 @@
         iterations.
 
-        NOTE 2:  P  should  be nonsingular. Exception will be thrown otherwise. It
-        also should be well conditioned, although only strict  non-singularity  is
-        tested.
+        NOTE 2:  P  should  be nonsingular. Exception will be thrown otherwise.
 
           -- ALGLIB --
              Copyright 13.10.2010 by Bochkanov Sergey
         *************************************************************************/
-        public static void minlbfgssetcholeskypreconditioner(minlbfgsstate state,
+        public static void minlbfgssetpreccholesky(minlbfgsstate state,
             double[,] p,
             bool isupper)
@@ -2372,5 +8111,5 @@
             double mx = 0;
 
-            ap.assert(apserv.isfinitertrmatrix(p, state.n, isupper), "MinLBFGSSetCholeskyPreconditioner: P contains infinite or NAN values!");
+            ap.assert(apserv.isfinitertrmatrix(p, state.n, isupper), "MinLBFGSSetPrecCholesky: P contains infinite or NAN values!");
             mx = 0;
             for(i=0; i<=state.n-1; i++)
@@ -2378,5 +8117,5 @@
                 mx = Math.Max(mx, Math.Abs(p[i,i]));
             }
-            ap.assert((double)(mx)>(double)(0), "MinLBFGSSetCholeskyPreconditioner: P is strictly singular!");
+            ap.assert((double)(mx)>(double)(0), "MinLBFGSSetPrecCholesky: P is strictly singular!");
             if( ap.rows(state.denseh)<state.n | ap.cols(state.denseh)<state.n )
             {
@@ -2396,4 +8135,102 @@
 
         /*************************************************************************
+        Modification  of  the  preconditioner:  diagonal of approximate Hessian is
+        used.
+
+        INPUT PARAMETERS:
+            State   -   structure which stores algorithm state
+            D       -   diagonal of the approximate Hessian, array[0..N-1],
+                        (if larger, only leading N elements are used).
+
+        NOTE:  you  can  change  preconditioner  "on  the  fly",  during algorithm
+        iterations.
+
+        NOTE 2: D[i] should be positive. Exception will be thrown otherwise.
+
+        NOTE 3: you should pass diagonal of approximate Hessian - NOT ITS INVERSE.
+
+          -- ALGLIB --
+             Copyright 13.10.2010 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlbfgssetprecdiag(minlbfgsstate state,
+            double[] d)
+        {
+            int i = 0;
+
+            ap.assert(ap.len(d)>=state.n, "MinLBFGSSetPrecDiag: D is too short");
+            for(i=0; i<=state.n-1; i++)
+            {
+                ap.assert(math.isfinite(d[i]), "MinLBFGSSetPrecDiag: D contains infinite or NAN elements");
+                ap.assert((double)(d[i])>(double)(0), "MinLBFGSSetPrecDiag: D contains non-positive elements");
+            }
+            apserv.rvectorsetlengthatleast(ref state.diagh, state.n);
+            state.prectype = 2;
+            for(i=0; i<=state.n-1; i++)
+            {
+                state.diagh[i] = d[i];
+            }
+        }
+
+
+        /*************************************************************************
+        Modification of the preconditioner: scale-based diagonal preconditioning.
+
+        This preconditioning mode can be useful when you  don't  have  approximate
+        diagonal of Hessian, but you know that your  variables  are  badly  scaled
+        (for  example,  one  variable is in [1,10], and another in [1000,100000]),
+        and most part of the ill-conditioning comes from different scales of vars.
+
+        In this case simple  scale-based  preconditioner,  with H[i] = 1/(s[i]^2),
+        can greatly improve convergence.
+
+        IMPRTANT: you should set scale of your variables  with  MinLBFGSSetScale()
+        call  (before  or after MinLBFGSSetPrecScale() call). Without knowledge of
+        the scale of your variables scale-based preconditioner will be  just  unit
+        matrix.
+
+        INPUT PARAMETERS:
+            State   -   structure which stores algorithm state
+
+          -- ALGLIB --
+             Copyright 13.10.2010 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlbfgssetprecscale(minlbfgsstate state)
+        {
+            state.prectype = 3;
+        }
+
+
+        /*************************************************************************
+        NOTES:
+
+        1. This function has two different implementations: one which  uses  exact
+           (analytical) user-supplied gradient,  and one which uses function value
+           only  and  numerically  differentiates  function  in  order  to  obtain
+           gradient.
+
+           Depending  on  the  specific  function  used to create optimizer object
+           (either MinLBFGSCreate() for analytical gradient  or  MinLBFGSCreateF()
+           for numerical differentiation) you should choose appropriate variant of
+           MinLBFGSOptimize() - one  which  accepts  function  AND gradient or one
+           which accepts function ONLY.
+
+           Be careful to choose variant of MinLBFGSOptimize() which corresponds to
+           your optimization scheme! Table below lists different  combinations  of
+           callback (function/gradient) passed to MinLBFGSOptimize()  and specific
+           function used to create optimizer.
+
+
+                             |         USER PASSED TO MinLBFGSOptimize()
+           CREATED WITH      |  function only   |  function and gradient
+           ------------------------------------------------------------
+           MinLBFGSCreateF() |     work                FAIL
+           MinLBFGSCreate()  |     FAIL                work
+
+           Here "FAIL" denotes inappropriate combinations  of  optimizer  creation
+           function  and  MinLBFGSOptimize()  version.   Attemps   to   use   such
+           combination (for example, to create optimizer with MinLBFGSCreateF() and
+           to pass gradient information to MinCGOptimize()) will lead to exception
+           being thrown. Either  you  did  not pass gradient when it WAS needed or
+           you passed gradient when it was NOT needed.
 
           -- ALGLIB --
@@ -2405,8 +8242,4 @@
             int n = 0;
             int m = 0;
-            int maxits = 0;
-            double epsf = 0;
-            double epsg = 0;
-            double epsx = 0;
             int i = 0;
             int j = 0;
@@ -2432,14 +8265,10 @@
                 n = state.rstate.ia[0];
                 m = state.rstate.ia[1];
-                maxits = state.rstate.ia[2];
-                i = state.rstate.ia[3];
-                j = state.rstate.ia[4];
-                ic = state.rstate.ia[5];
-                mcinfo = state.rstate.ia[6];
-                epsf = state.rstate.ra[0];
-                epsg = state.rstate.ra[1];
-                epsx = state.rstate.ra[2];
-                v = state.rstate.ra[3];
-                vv = state.rstate.ra[4];
+                i = state.rstate.ia[2];
+                j = state.rstate.ia[3];
+                ic = state.rstate.ia[4];
+                mcinfo = state.rstate.ia[5];
+                v = state.rstate.ra[0];
+                vv = state.rstate.ra[1];
             }
             else
@@ -2447,14 +8276,10 @@
                 n = -983;
                 m = -989;
-                maxits = -834;
-                i = 900;
-                j = -287;
-                ic = 364;
-                mcinfo = 214;
-                epsf = -338;
-                epsg = -686;
-                epsx = 912;
-                v = 585;
-                vv = 497;
+                i = -834;
+                j = 900;
+                ic = -287;
+                mcinfo = 364;
+                v = 214;
+                vv = -338;
             }
             if( state.rstate.stage==0 )
@@ -2473,4 +8298,44 @@
             {
                 goto lbl_3;
+            }
+            if( state.rstate.stage==4 )
+            {
+                goto lbl_4;
+            }
+            if( state.rstate.stage==5 )
+            {
+                goto lbl_5;
+            }
+            if( state.rstate.stage==6 )
+            {
+                goto lbl_6;
+            }
+            if( state.rstate.stage==7 )
+            {
+                goto lbl_7;
+            }
+            if( state.rstate.stage==8 )
+            {
+                goto lbl_8;
+            }
+            if( state.rstate.stage==9 )
+            {
+                goto lbl_9;
+            }
+            if( state.rstate.stage==10 )
+            {
+                goto lbl_10;
+            }
+            if( state.rstate.stage==11 )
+            {
+                goto lbl_11;
+            }
+            if( state.rstate.stage==12 )
+            {
+                goto lbl_12;
+            }
+            if( state.rstate.stage==13 )
+            {
+                goto lbl_13;
             }
             
@@ -2485,8 +8350,4 @@
             n = state.n;
             m = state.m;
-            epsg = state.epsg;
-            epsf = state.epsf;
-            epsx = state.epsx;
-            maxits = state.maxits;
             state.repterminationtype = 0;
             state.repiterationscount = 0;
@@ -2497,4 +8358,8 @@
             //
             clearrequestfields(state);
+            if( (double)(state.diffstep)!=(double)(0) )
+            {
+                goto lbl_14;
+            }
             state.needfg = true;
             state.rstate.stage = 0;
@@ -2502,24 +8367,66 @@
         lbl_0:
             state.needfg = false;
-            if( !state.xrep )
-            {
-                goto lbl_4;
-            }
-            clearrequestfields(state);
-            state.xupdated = true;
+            goto lbl_15;
+        lbl_14:
+            state.needf = true;
             state.rstate.stage = 1;
             goto lbl_rcomm;
         lbl_1:
+            state.fbase = state.f;
+            i = 0;
+        lbl_16:
+            if( i>n-1 )
+            {
+                goto lbl_18;
+            }
+            v = state.x[i];
+            state.x[i] = v-state.diffstep*state.s[i];
+            state.rstate.stage = 2;
+            goto lbl_rcomm;
+        lbl_2:
+            state.fm2 = state.f;
+            state.x[i] = v-0.5*state.diffstep*state.s[i];
+            state.rstate.stage = 3;
+            goto lbl_rcomm;
+        lbl_3:
+            state.fm1 = state.f;
+            state.x[i] = v+0.5*state.diffstep*state.s[i];
+            state.rstate.stage = 4;
+            goto lbl_rcomm;
+        lbl_4:
+            state.fp1 = state.f;
+            state.x[i] = v+state.diffstep*state.s[i];
+            state.rstate.stage = 5;
+            goto lbl_rcomm;
+        lbl_5:
+            state.fp2 = state.f;
+            state.x[i] = v;
+            state.g[i] = (8*(state.fp1-state.fm1)-(state.fp2-state.fm2))/(6*state.diffstep*state.s[i]);
+            i = i+1;
+            goto lbl_16;
+        lbl_18:
+            state.f = state.fbase;
+            state.needf = false;
+        lbl_15:
+            optserv.trimprepare(state.f, ref state.trimthreshold);
+            if( !state.xrep )
+            {
+                goto lbl_19;
+            }
+            clearrequestfields(state);
+            state.xupdated = true;
+            state.rstate.stage = 6;
+            goto lbl_rcomm;
+        lbl_6:
             state.xupdated = false;
-        lbl_4:
+        lbl_19:
             state.repnfev = 1;
             state.fold = state.f;
-            v = 0.0;
-            for(i_=0; i_<=n-1;i_++)
-            {
-                v += state.g[i_]*state.g[i_];
-            }
-            v = Math.Sqrt(v);
-            if( (double)(v)<=(double)(epsg) )
+            v = 0;
+            for(i=0; i<=n-1; i++)
+            {
+                v = v+math.sqr(state.g[i]*state.s[i]);
+            }
+            if( (double)(Math.Sqrt(v))<=(double)(state.epsg) )
             {
                 state.repterminationtype = 4;
@@ -2532,15 +8439,28 @@
             // Apply preconditioner, if we have something other than default.
             //
-            if( (double)(state.stpmax)==(double)(0) )
-            {
-                state.stp = Math.Min(1.0/v, 1);
-            }
-            else
-            {
-                state.stp = Math.Min(1.0/v, state.stpmax);
-            }
             for(i_=0; i_<=n-1;i_++)
             {
                 state.d[i_] = -state.g[i_];
+            }
+            if( state.prectype==0 )
+            {
+                
+                //
+                // Default preconditioner is used, but we can't use it before iterations will start
+                //
+                v = 0.0;
+                for(i_=0; i_<=n-1;i_++)
+                {
+                    v += state.g[i_]*state.g[i_];
+                }
+                v = Math.Sqrt(v);
+                if( (double)(state.stpmax)==(double)(0) )
+                {
+                    state.stp = Math.Min(1.0/v, 1);
+                }
+                else
+                {
+                    state.stp = Math.Min(1.0/v, state.stpmax);
+                }
             }
             if( state.prectype==1 )
@@ -2551,4 +8471,29 @@
                 //
                 fbls.fblscholeskysolve(state.denseh, 1.0, n, true, ref state.d, ref state.autobuf);
+                state.stp = 1;
+            }
+            if( state.prectype==2 )
+            {
+                
+                //
+                // diagonal approximation is used
+                //
+                for(i=0; i<=n-1; i++)
+                {
+                    state.d[i] = state.d[i]/state.diagh[i];
+                }
+                state.stp = 1;
+            }
+            if( state.prectype==3 )
+            {
+                
+                //
+                // scale-based preconditioner is used
+                //
+                for(i=0; i<=n-1; i++)
+                {
+                    state.d[i] = state.d[i]*state.s[i]*state.s[i];
+                }
+                state.stp = 1;
             }
             
@@ -2557,8 +8502,8 @@
             //
             state.k = 0;
-        lbl_6:
+        lbl_21:
             if( false )
             {
-                goto lbl_7;
+                goto lbl_22;
             }
             
@@ -2574,9 +8519,9 @@
             for(i_=0; i_<=n-1;i_++)
             {
-                state.s[state.p,i_] = -state.x[i_];
+                state.sk[state.p,i_] = -state.x[i_];
             }
             for(i_=0; i_<=n-1;i_++)
             {
-                state.y[state.p,i_] = -state.g[i_];
+                state.yk[state.p,i_] = -state.g[i_];
             }
             
@@ -2591,22 +8536,69 @@
             }
             linmin.linminnormalized(ref state.d, ref state.stp, n);
-            linmin.mcsrch(n, ref state.x, ref state.f, ref state.g, state.d, ref state.stp, state.stpmax, ref mcinfo, ref state.nfev, ref state.work, state.lstate, ref state.mcstage);
+            linmin.mcsrch(n, ref state.x, ref state.f, ref state.g, state.d, ref state.stp, state.stpmax, gtol, ref mcinfo, ref state.nfev, ref state.work, state.lstate, ref state.mcstage);
+        lbl_23:
+            if( state.mcstage==0 )
+            {
+                goto lbl_24;
+            }
+            clearrequestfields(state);
+            if( (double)(state.diffstep)!=(double)(0) )
+            {
+                goto lbl_25;
+            }
+            state.needfg = true;
+            state.rstate.stage = 7;
+            goto lbl_rcomm;
+        lbl_7:
+            state.needfg = false;
+            goto lbl_26;
+        lbl_25:
+            state.needf = true;
+            state.rstate.stage = 8;
+            goto lbl_rcomm;
         lbl_8:
-            if( state.mcstage==0 )
-            {
-                goto lbl_9;
-            }
-            clearrequestfields(state);
-            state.needfg = true;
-            state.rstate.stage = 2;
+            state.fbase = state.f;
+            i = 0;
+        lbl_27:
+            if( i>n-1 )
+            {
+                goto lbl_29;
+            }
+            v = state.x[i];
+            state.x[i] = v-state.diffstep*state.s[i];
+            state.rstate.stage = 9;
             goto lbl_rcomm;
-        lbl_2:
-            state.needfg = false;
-            linmin.mcsrch(n, ref state.x, ref state.f, ref state.g, state.d, ref state.stp, state.stpmax, ref mcinfo, ref state.nfev, ref state.work, state.lstate, ref state.mcstage);
-            goto lbl_8;
         lbl_9:
+            state.fm2 = state.f;
+            state.x[i] = v-0.5*state.diffstep*state.s[i];
+            state.rstate.stage = 10;
+            goto lbl_rcomm;
+        lbl_10:
+            state.fm1 = state.f;
+            state.x[i] = v+0.5*state.diffstep*state.s[i];
+            state.rstate.stage = 11;
+            goto lbl_rcomm;
+        lbl_11:
+            state.fp1 = state.f;
+            state.x[i] = v+state.diffstep*state.s[i];
+            state.rstate.stage = 12;
+            goto lbl_rcomm;
+        lbl_12:
+            state.fp2 = state.f;
+            state.x[i] = v;
+            state.g[i] = (8*(state.fp1-state.fm1)-(state.fp2-state.fm2))/(6*state.diffstep*state.s[i]);
+            i = i+1;
+            goto lbl_27;
+        lbl_29:
+            state.f = state.fbase;
+            state.needf = false;
+        lbl_26:
+            optserv.trimfunction(ref state.f, ref state.g, n, state.trimthreshold);
+            linmin.mcsrch(n, ref state.x, ref state.f, ref state.g, state.d, ref state.stp, state.stpmax, gtol, ref mcinfo, ref state.nfev, ref state.work, state.lstate, ref state.mcstage);
+            goto lbl_23;
+        lbl_24:
             if( !state.xrep )
             {
-                goto lbl_10;
+                goto lbl_30;
             }
             
